/*! \file piline.h
 * \ingroup Math
 * \brief
 * \~english Two-dimensional line class
 * \~russian Класс отрезка двумерной линии
*/
/*
	PIP - Platform Independent Primitives
	Two-dimensional line class
	Ivan Pelipenko peri4ko@yandex.ru, Andrey Bychkov work.a.b@yandex.ru

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef PILINE_H
#define PILINE_H

#include "pipoint.h"


/*! \brief
 * \~english Two-dimensional line class
 * \~russian Класс отрезка двумерной линии
 * \~\details
 * \~russian
 * Этот класс описывает линию на плоскости в прямоугольной системе координат
 */
template<typename Type>
class PIP_EXPORT PILine {
	static_assert(std::is_arithmetic<Type>::value, "Type must be arithmetic");
public:
	PIPoint<Type> p0;
	PIPoint<Type> p1;

	//! \~russian
	//! Пустой конструктор.
	//! \details 
	//! При выполнении пустого конструктора координаты не изменяются.
	//! Начало и конец совпадают.
	PILine() {}

	//! \~russian
	//! Создает линию по двум принятым точкам \a PIPoint начала и конца.
	PILine(const PIPoint<Type> & p0_, const PIPoint<Type> & p1_) {
		p0 = p0_;
		p1 = p1_;
	}

	//! \~russian
	//! Создает линию по принятым координатам начала и конца.
	PILine(Type x0, Type y0, Type x1, Type y1) {
		p0.set(x0, y0);
		p1.set(x1, y1);
	}

	//! \~russian
	//! Задать новые координаты начала и конца по двум принятым точкам \a PIPoint.
	PILine<Type> & set(const PIPoint<Type> & p0_, const PIPoint<Type> & p1_) {
		p0 = p0_;
		p1 = p1_;
		return *this;
	}

	//! \~russian
	//! Задать новые координаты начала и конца.
	PILine<Type> & set(Type x0, Type y0, Type x1, Type y1) {
		p0.set(x0, y0);
		p1.set(x1, y1);
		return *this;
	}

	//! \~russian
	//! Проверить на совпадение координат начала и конца.
	bool isEmpty() const {
		return (p0 == p1);
	}

	//! \~russian
	//! Вычислить ширину прямоугольника, диагональю которого является данный отрезок.
	Type width() const {return piAbs<Type>(p1.x - p0.x);}

	//! \~russian
	//! Вычислить высоту прямоугольника, диагональю которого является данный отрезок.
	Type height() const {return piAbs<Type>(p1.y - p0.y);}

	//! \~russian
	//! Сдвинуть линию на \a x, \a y.
	PILine<Type> & translate(Type x, Type y) {
		p0.translate(x, y);
		p1.translate(x, y);
		return *this;
	}

	//! \~russian
	//! Сдвинуть линию на значение координат точки \a PIPoint.
	PILine<Type> & translate(const PIPoint<Type> & p) {
		p0.translate(p);
		p1.translate(p);
		return *this;
	}

	//! Создать копию отрезка и сдвинуть её на `x` и `y`.
	PILine<Type> translated(Type x, Type y) const {
		PILine<Type> l(*this);
		l.translate(x, y);
		return l;
	}

	//! \~russian
	//! Создать копию отрезка и сдвинуть её на значение координат точки \a PIPoint.
	PILine<Type> translated(const PIPoint<Type> & p) const {
		PILine<Type> l(*this);
		l.translate(p);
		return l;
	}

	//! \~russian
	//! Сдвинуть линию на \a x, \a y.
	//! \details Является копией метода \a translate().
	PILine<Type> & move(Type x, Type y) {return translate(x, y);}

	//! \~russian
	//! Сдвинуть линию на значение координат точки \a PIPoint.
	//! \details Является копией метода \a translate().
	PILine<Type> & move(const PIPoint<Type> & p) {return translate(p);}

	//! \~russian
	//! Создать копию отрезка и сдвинуть её на \a x, \a y.
	//! \details Является копией метода \a translated().
	PILine<Type> moved(Type x, Type y) const {
		PILine<Type> l(*this);
		l.translate(x, y);
		return l;
	}
	
	//! \~russian
	//! Создать копию отрезка и сдвинуть её на значение координат точки \a PIPoint.
	//! \details Является копией метода \a translated().
	PILine<Type> moved(const PIPoint<Type> & p) const {
		PILine<Type> l(*this);
		l.translate(p);
		return l;
	}

	//! \~russian Сдвинуть линию по двум координатам на значение \a x.
	void operator +=(Type x) {translate(x, x);}

	//! \~russian Сдвинуть линию по двум координатам на величину координат точки \a PIPoint.
	void operator +=(const PIPoint<Type> & p) {translate(p);}

	//! \~russian Сдвинуть линию по двум координатам на значение \a x.
	void operator -=(Type x) {translate(-x, -x);}

	//! \~russian Сдвинуть линию по двум координатам на величину координат точки \a PIPoint.
	void operator -=(const PIPoint<Type> & p) {translate(-p);}

	//! \~russian Сдвинуть линию по двум координатам на величину координат точки \a PIPoint.
	PILine<Type> operator +(const PIPoint<Type> & p) {return  translated(p);}

	//! \~russian Сдвинуть линию по двум координатам на величину координат точки \a PIPoint.
	PILine<Type> operator -(const PIPoint<Type> & p) {return  translated(-p);}

	//! \~russian Проверить равенство координат двух отрезков.
	bool operator ==(const PILine<Type> & r) const {return (p0 == r.p0 && p1 == r.p1);}

	//! \~russian Проверить неравенство координат двух отрезков.
	bool operator !=(const PILine<Type> & r) const {return (p1 != r.p1 || p1 != r.p1);}
};

//! \~russian Перегруженный оператор для вывода координат в \a PICout.
template<typename Type>
PICout operator <<(PICout & s, const PILine<Type> & v) {
	s.saveAndSetControls(0);
	s << "Line{" << v.p0 << ", " << v.p1 << "}";
	s.restoreControls();
	return s;
}

typedef PILine<int> PILinei;
typedef PILine<uint> PILineu;
typedef PILine<float> PILinef;
typedef PILine<double> PILined;

#endif // PILINE_H
